version: '3.8'

networks:
  ledius:
    external: true
    name: ledius

services:
  order-matching-engine:
    build:
      context: .
      dockerfile: ./docker/exchange/Dockerfile
    container_name: order-matching-engine
    hostname: order-matching-engine
    environment:
      - "RUNNING_APP=exchange"
    volumes:
      - ./apps:/app/apps
      - ./libs:/app/libs
      - ./node_modules:/app/node_modules
    env_file: .env
    networks:
      - ledius

  order-matching-engine-gateway:
    build:
      context: .
      dockerfile: ./docker/exchange/Dockerfile
    container_name: order-matching-engine-gateway
    hostname: order-matching-engine-gateway
    environment:
      - "RUNNING_APP=gateway"
    volumes:
      - ./apps:/app/apps
      - ./libs:/app/libs
      - ./node_modules:/app/node_modules
    env_file: .env
    ports:
      - "3000:3000"
    networks:
      - ledius

  order-matching-engine-market:
    build:
      context: .
      dockerfile: ./docker/exchange/Dockerfile
    container_name: order-matching-engine-market
    hostname: order-matching-engine-market
    environment:
      - "RUNNING_APP=market"
    volumes:
      - ./apps:/app/apps
      - ./libs:/app/libs
      - ./node_modules:/app/node_modules
    env_file: .env
    networks:
      - ledius

  order-matching-engine-mongo:
    image: mongo
    hostname: order-matching-engine-mongo
    container_name: order-matching-engine-mongo
    ports:
      - "27017:27017"
    networks:
      - ledius

  order-matching-engine-rabbitmq:
    image: rabbitmq:3-management
    hostname: order-matching-engine-rabbitmq
    container_name: order-matching-engine-rabbitmq
    ports:
      - "5672:5672"
      - "15671:15671"
      - "15672:15672"
    networks:
      - ledius
